
#line 1 "src/pkginfo.rl"
#include "pkginfo.h"

#include <err.h>
#include "package.h"
#include "util.h"


#line 52 "src/pkginfo.rl"



#line 15 "src/pkginfo.c"
static const int pkginfo_start = 125;
static const int pkginfo_error = 0;

static const int pkginfo_en_main = 125;


#line 55 "src/pkginfo.rl"

void pkginfo_parser_init(struct pkginfo_parser *parser)
{
    *parser = (struct pkginfo_parser){0};
    
#line 60 "src/pkginfo.rl"
    
#line 30 "src/pkginfo.c"
	{
	 parser->cs = pkginfo_start;
	}

#line 61 "src/pkginfo.rl"
}

ssize_t pkginfo_parser_feed(struct pkginfo_parser *parser, struct pkg *pkg,
                         char *buf, size_t buf_len)
{
    char *p = buf;
    char *pe = p + buf_len;

    
#line 70 "src/pkginfo.rl"
    
#line 47 "src/pkginfo.c"
	{
	if ( p == pe )
		goto _test_eof;
	switch (  parser->cs )
	{
tr10:
#line 17 "src/pkginfo.rl"
	{
        if (parser->pos) {
            const char *entry = parser->store;
            const size_t entry_len = parser->pos;
            parser->store[parser->pos] = 0;
            parser->pos = 0;

            package_set(pkg, parser->entry, entry, entry_len);
        }
    }
	goto st125;
st125:
	if ( ++p == pe )
		goto _test_eof125;
case 125:
#line 70 "src/pkginfo.c"
	switch( (*p) ) {
		case 35: goto st1;
		case 97: goto st2;
		case 98: goto st9;
		case 99: goto st23;
		case 100: goto st41;
		case 103: goto st47;
		case 108: goto st52;
		case 109: goto st59;
		case 111: goto st69;
		case 112: goto st78;
		case 114: goto st110;
		case 115: goto st118;
		case 117: goto st122;
	}
	goto st0;
st0:
 parser->cs = 0;
	goto _out;
st1:
	if ( ++p == pe )
		goto _test_eof1;
case 1:
	if ( (*p) == 10 )
		goto st125;
	goto st1;
st2:
	if ( ++p == pe )
		goto _test_eof2;
case 2:
	if ( (*p) == 114 )
		goto st3;
	goto st0;
st3:
	if ( ++p == pe )
		goto _test_eof3;
case 3:
	if ( (*p) == 99 )
		goto st4;
	goto st0;
st4:
	if ( ++p == pe )
		goto _test_eof4;
case 4:
	if ( (*p) == 104 )
		goto st5;
	goto st0;
st5:
	if ( ++p == pe )
		goto _test_eof5;
case 5:
	if ( (*p) == 32 )
		goto tr6;
	goto st0;
tr6:
#line 36 "src/pkginfo.rl"
	{ parser->entry = PKG_ARCH; }
	goto st6;
tr17:
#line 46 "src/pkginfo.rl"
	{ parser->entry = PKG_BACKUP; }
	goto st6;
tr25:
#line 33 "src/pkginfo.rl"
	{ parser->entry = PKG_BUILDDATE; }
	goto st6;
tr37:
#line 45 "src/pkginfo.rl"
	{ parser->entry = PKG_CHECKDEPENDS; }
	goto st6;
tr44:
#line 41 "src/pkginfo.rl"
	{ parser->entry = PKG_CONFLICTS; }
	goto st6;
tr50:
#line 40 "src/pkginfo.rl"
	{ parser->entry = PKG_DEPENDS; }
	goto st6;
tr55:
#line 37 "src/pkginfo.rl"
	{ parser->entry = PKG_GROUPS; }
	goto st6;
tr62:
#line 38 "src/pkginfo.rl"
	{ parser->entry = PKG_LICENSE; }
	goto st6;
tr72:
#line 44 "src/pkginfo.rl"
	{ parser->entry = PKG_MAKEDEPENDS; }
	goto st6;
tr81:
#line 43 "src/pkginfo.rl"
	{ parser->entry = PKG_OPTDEPENDS; }
	goto st6;
tr91:
#line 34 "src/pkginfo.rl"
	{ parser->entry = PKG_PACKAGER; }
	goto st6;
tr100:
#line 29 "src/pkginfo.rl"
	{ parser->entry = PKG_PKGBASE; }
	goto st6;
tr104:
#line 31 "src/pkginfo.rl"
	{ parser->entry = PKG_DESCRIPTION; }
	goto st6;
tr108:
#line 28 "src/pkginfo.rl"
	{ parser->entry = PKG_PKGNAME; }
	goto st6;
tr111:
#line 30 "src/pkginfo.rl"
	{ parser->entry = PKG_VERSION; }
	goto st6;
tr118:
#line 42 "src/pkginfo.rl"
	{ parser->entry = PKG_PROVIDES; }
	goto st6;
tr126:
#line 39 "src/pkginfo.rl"
	{ parser->entry = PKG_REPLACES; }
	goto st6;
tr130:
#line 35 "src/pkginfo.rl"
	{ parser->entry = PKG_ISIZE; }
	goto st6;
tr133:
#line 32 "src/pkginfo.rl"
	{ parser->entry = PKG_URL; }
	goto st6;
st6:
	if ( ++p == pe )
		goto _test_eof6;
case 6:
#line 205 "src/pkginfo.c"
	if ( (*p) == 61 )
		goto st7;
	goto st0;
st7:
	if ( ++p == pe )
		goto _test_eof7;
case 7:
	if ( (*p) == 32 )
		goto st8;
	goto st0;
tr9:
#line 10 "src/pkginfo.rl"
	{
        parser->store[parser->pos++] = (*p);
        if (parser->pos == LINE_MAX) {
            errx(1, "desc line too long");
        }
    }
	goto st8;
st8:
	if ( ++p == pe )
		goto _test_eof8;
case 8:
#line 229 "src/pkginfo.c"
	if ( (*p) == 10 )
		goto tr10;
	goto tr9;
st9:
	if ( ++p == pe )
		goto _test_eof9;
case 9:
	switch( (*p) ) {
		case 97: goto st10;
		case 117: goto st15;
	}
	goto st0;
st10:
	if ( ++p == pe )
		goto _test_eof10;
case 10:
	if ( (*p) == 99 )
		goto st11;
	goto st0;
st11:
	if ( ++p == pe )
		goto _test_eof11;
case 11:
	if ( (*p) == 107 )
		goto st12;
	goto st0;
st12:
	if ( ++p == pe )
		goto _test_eof12;
case 12:
	if ( (*p) == 117 )
		goto st13;
	goto st0;
st13:
	if ( ++p == pe )
		goto _test_eof13;
case 13:
	if ( (*p) == 112 )
		goto st14;
	goto st0;
st14:
	if ( ++p == pe )
		goto _test_eof14;
case 14:
	if ( (*p) == 32 )
		goto tr17;
	goto st0;
st15:
	if ( ++p == pe )
		goto _test_eof15;
case 15:
	if ( (*p) == 105 )
		goto st16;
	goto st0;
st16:
	if ( ++p == pe )
		goto _test_eof16;
case 16:
	if ( (*p) == 108 )
		goto st17;
	goto st0;
st17:
	if ( ++p == pe )
		goto _test_eof17;
case 17:
	if ( (*p) == 100 )
		goto st18;
	goto st0;
st18:
	if ( ++p == pe )
		goto _test_eof18;
case 18:
	if ( (*p) == 100 )
		goto st19;
	goto st0;
st19:
	if ( ++p == pe )
		goto _test_eof19;
case 19:
	if ( (*p) == 97 )
		goto st20;
	goto st0;
st20:
	if ( ++p == pe )
		goto _test_eof20;
case 20:
	if ( (*p) == 116 )
		goto st21;
	goto st0;
st21:
	if ( ++p == pe )
		goto _test_eof21;
case 21:
	if ( (*p) == 101 )
		goto st22;
	goto st0;
st22:
	if ( ++p == pe )
		goto _test_eof22;
case 22:
	if ( (*p) == 32 )
		goto tr25;
	goto st0;
st23:
	if ( ++p == pe )
		goto _test_eof23;
case 23:
	switch( (*p) ) {
		case 104: goto st24;
		case 111: goto st34;
	}
	goto st0;
st24:
	if ( ++p == pe )
		goto _test_eof24;
case 24:
	if ( (*p) == 101 )
		goto st25;
	goto st0;
st25:
	if ( ++p == pe )
		goto _test_eof25;
case 25:
	if ( (*p) == 99 )
		goto st26;
	goto st0;
st26:
	if ( ++p == pe )
		goto _test_eof26;
case 26:
	if ( (*p) == 107 )
		goto st27;
	goto st0;
st27:
	if ( ++p == pe )
		goto _test_eof27;
case 27:
	if ( (*p) == 100 )
		goto st28;
	goto st0;
st28:
	if ( ++p == pe )
		goto _test_eof28;
case 28:
	if ( (*p) == 101 )
		goto st29;
	goto st0;
st29:
	if ( ++p == pe )
		goto _test_eof29;
case 29:
	if ( (*p) == 112 )
		goto st30;
	goto st0;
st30:
	if ( ++p == pe )
		goto _test_eof30;
case 30:
	if ( (*p) == 101 )
		goto st31;
	goto st0;
st31:
	if ( ++p == pe )
		goto _test_eof31;
case 31:
	if ( (*p) == 110 )
		goto st32;
	goto st0;
st32:
	if ( ++p == pe )
		goto _test_eof32;
case 32:
	if ( (*p) == 100 )
		goto st33;
	goto st0;
st33:
	if ( ++p == pe )
		goto _test_eof33;
case 33:
	if ( (*p) == 32 )
		goto tr37;
	goto st0;
st34:
	if ( ++p == pe )
		goto _test_eof34;
case 34:
	if ( (*p) == 110 )
		goto st35;
	goto st0;
st35:
	if ( ++p == pe )
		goto _test_eof35;
case 35:
	if ( (*p) == 102 )
		goto st36;
	goto st0;
st36:
	if ( ++p == pe )
		goto _test_eof36;
case 36:
	if ( (*p) == 108 )
		goto st37;
	goto st0;
st37:
	if ( ++p == pe )
		goto _test_eof37;
case 37:
	if ( (*p) == 105 )
		goto st38;
	goto st0;
st38:
	if ( ++p == pe )
		goto _test_eof38;
case 38:
	if ( (*p) == 99 )
		goto st39;
	goto st0;
st39:
	if ( ++p == pe )
		goto _test_eof39;
case 39:
	if ( (*p) == 116 )
		goto st40;
	goto st0;
st40:
	if ( ++p == pe )
		goto _test_eof40;
case 40:
	if ( (*p) == 32 )
		goto tr44;
	goto st0;
st41:
	if ( ++p == pe )
		goto _test_eof41;
case 41:
	if ( (*p) == 101 )
		goto st42;
	goto st0;
st42:
	if ( ++p == pe )
		goto _test_eof42;
case 42:
	if ( (*p) == 112 )
		goto st43;
	goto st0;
st43:
	if ( ++p == pe )
		goto _test_eof43;
case 43:
	if ( (*p) == 101 )
		goto st44;
	goto st0;
st44:
	if ( ++p == pe )
		goto _test_eof44;
case 44:
	if ( (*p) == 110 )
		goto st45;
	goto st0;
st45:
	if ( ++p == pe )
		goto _test_eof45;
case 45:
	if ( (*p) == 100 )
		goto st46;
	goto st0;
st46:
	if ( ++p == pe )
		goto _test_eof46;
case 46:
	if ( (*p) == 32 )
		goto tr50;
	goto st0;
st47:
	if ( ++p == pe )
		goto _test_eof47;
case 47:
	if ( (*p) == 114 )
		goto st48;
	goto st0;
st48:
	if ( ++p == pe )
		goto _test_eof48;
case 48:
	if ( (*p) == 111 )
		goto st49;
	goto st0;
st49:
	if ( ++p == pe )
		goto _test_eof49;
case 49:
	if ( (*p) == 117 )
		goto st50;
	goto st0;
st50:
	if ( ++p == pe )
		goto _test_eof50;
case 50:
	if ( (*p) == 112 )
		goto st51;
	goto st0;
st51:
	if ( ++p == pe )
		goto _test_eof51;
case 51:
	if ( (*p) == 32 )
		goto tr55;
	goto st0;
st52:
	if ( ++p == pe )
		goto _test_eof52;
case 52:
	if ( (*p) == 105 )
		goto st53;
	goto st0;
st53:
	if ( ++p == pe )
		goto _test_eof53;
case 53:
	if ( (*p) == 99 )
		goto st54;
	goto st0;
st54:
	if ( ++p == pe )
		goto _test_eof54;
case 54:
	if ( (*p) == 101 )
		goto st55;
	goto st0;
st55:
	if ( ++p == pe )
		goto _test_eof55;
case 55:
	if ( (*p) == 110 )
		goto st56;
	goto st0;
st56:
	if ( ++p == pe )
		goto _test_eof56;
case 56:
	if ( (*p) == 115 )
		goto st57;
	goto st0;
st57:
	if ( ++p == pe )
		goto _test_eof57;
case 57:
	if ( (*p) == 101 )
		goto st58;
	goto st0;
st58:
	if ( ++p == pe )
		goto _test_eof58;
case 58:
	if ( (*p) == 32 )
		goto tr62;
	goto st0;
st59:
	if ( ++p == pe )
		goto _test_eof59;
case 59:
	if ( (*p) == 97 )
		goto st60;
	goto st0;
st60:
	if ( ++p == pe )
		goto _test_eof60;
case 60:
	if ( (*p) == 107 )
		goto st61;
	goto st0;
st61:
	if ( ++p == pe )
		goto _test_eof61;
case 61:
	if ( (*p) == 101 )
		goto st62;
	goto st0;
st62:
	if ( ++p == pe )
		goto _test_eof62;
case 62:
	if ( (*p) == 100 )
		goto st63;
	goto st0;
st63:
	if ( ++p == pe )
		goto _test_eof63;
case 63:
	if ( (*p) == 101 )
		goto st64;
	goto st0;
st64:
	if ( ++p == pe )
		goto _test_eof64;
case 64:
	if ( (*p) == 112 )
		goto st65;
	goto st0;
st65:
	if ( ++p == pe )
		goto _test_eof65;
case 65:
	if ( (*p) == 101 )
		goto st66;
	goto st0;
st66:
	if ( ++p == pe )
		goto _test_eof66;
case 66:
	if ( (*p) == 110 )
		goto st67;
	goto st0;
st67:
	if ( ++p == pe )
		goto _test_eof67;
case 67:
	if ( (*p) == 100 )
		goto st68;
	goto st0;
st68:
	if ( ++p == pe )
		goto _test_eof68;
case 68:
	if ( (*p) == 32 )
		goto tr72;
	goto st0;
st69:
	if ( ++p == pe )
		goto _test_eof69;
case 69:
	if ( (*p) == 112 )
		goto st70;
	goto st0;
st70:
	if ( ++p == pe )
		goto _test_eof70;
case 70:
	if ( (*p) == 116 )
		goto st71;
	goto st0;
st71:
	if ( ++p == pe )
		goto _test_eof71;
case 71:
	if ( (*p) == 100 )
		goto st72;
	goto st0;
st72:
	if ( ++p == pe )
		goto _test_eof72;
case 72:
	if ( (*p) == 101 )
		goto st73;
	goto st0;
st73:
	if ( ++p == pe )
		goto _test_eof73;
case 73:
	if ( (*p) == 112 )
		goto st74;
	goto st0;
st74:
	if ( ++p == pe )
		goto _test_eof74;
case 74:
	if ( (*p) == 101 )
		goto st75;
	goto st0;
st75:
	if ( ++p == pe )
		goto _test_eof75;
case 75:
	if ( (*p) == 110 )
		goto st76;
	goto st0;
st76:
	if ( ++p == pe )
		goto _test_eof76;
case 76:
	if ( (*p) == 100 )
		goto st77;
	goto st0;
st77:
	if ( ++p == pe )
		goto _test_eof77;
case 77:
	if ( (*p) == 32 )
		goto tr81;
	goto st0;
st78:
	if ( ++p == pe )
		goto _test_eof78;
case 78:
	switch( (*p) ) {
		case 97: goto st79;
		case 107: goto st86;
		case 114: goto st103;
	}
	goto st0;
st79:
	if ( ++p == pe )
		goto _test_eof79;
case 79:
	if ( (*p) == 99 )
		goto st80;
	goto st0;
st80:
	if ( ++p == pe )
		goto _test_eof80;
case 80:
	if ( (*p) == 107 )
		goto st81;
	goto st0;
st81:
	if ( ++p == pe )
		goto _test_eof81;
case 81:
	if ( (*p) == 97 )
		goto st82;
	goto st0;
st82:
	if ( ++p == pe )
		goto _test_eof82;
case 82:
	if ( (*p) == 103 )
		goto st83;
	goto st0;
st83:
	if ( ++p == pe )
		goto _test_eof83;
case 83:
	if ( (*p) == 101 )
		goto st84;
	goto st0;
st84:
	if ( ++p == pe )
		goto _test_eof84;
case 84:
	if ( (*p) == 114 )
		goto st85;
	goto st0;
st85:
	if ( ++p == pe )
		goto _test_eof85;
case 85:
	if ( (*p) == 32 )
		goto tr91;
	goto st0;
st86:
	if ( ++p == pe )
		goto _test_eof86;
case 86:
	if ( (*p) == 103 )
		goto st87;
	goto st0;
st87:
	if ( ++p == pe )
		goto _test_eof87;
case 87:
	switch( (*p) ) {
		case 98: goto st88;
		case 100: goto st92;
		case 110: goto st96;
		case 118: goto st100;
	}
	goto st0;
st88:
	if ( ++p == pe )
		goto _test_eof88;
case 88:
	if ( (*p) == 97 )
		goto st89;
	goto st0;
st89:
	if ( ++p == pe )
		goto _test_eof89;
case 89:
	if ( (*p) == 115 )
		goto st90;
	goto st0;
st90:
	if ( ++p == pe )
		goto _test_eof90;
case 90:
	if ( (*p) == 101 )
		goto st91;
	goto st0;
st91:
	if ( ++p == pe )
		goto _test_eof91;
case 91:
	if ( (*p) == 32 )
		goto tr100;
	goto st0;
st92:
	if ( ++p == pe )
		goto _test_eof92;
case 92:
	if ( (*p) == 101 )
		goto st93;
	goto st0;
st93:
	if ( ++p == pe )
		goto _test_eof93;
case 93:
	if ( (*p) == 115 )
		goto st94;
	goto st0;
st94:
	if ( ++p == pe )
		goto _test_eof94;
case 94:
	if ( (*p) == 99 )
		goto st95;
	goto st0;
st95:
	if ( ++p == pe )
		goto _test_eof95;
case 95:
	if ( (*p) == 32 )
		goto tr104;
	goto st0;
st96:
	if ( ++p == pe )
		goto _test_eof96;
case 96:
	if ( (*p) == 97 )
		goto st97;
	goto st0;
st97:
	if ( ++p == pe )
		goto _test_eof97;
case 97:
	if ( (*p) == 109 )
		goto st98;
	goto st0;
st98:
	if ( ++p == pe )
		goto _test_eof98;
case 98:
	if ( (*p) == 101 )
		goto st99;
	goto st0;
st99:
	if ( ++p == pe )
		goto _test_eof99;
case 99:
	if ( (*p) == 32 )
		goto tr108;
	goto st0;
st100:
	if ( ++p == pe )
		goto _test_eof100;
case 100:
	if ( (*p) == 101 )
		goto st101;
	goto st0;
st101:
	if ( ++p == pe )
		goto _test_eof101;
case 101:
	if ( (*p) == 114 )
		goto st102;
	goto st0;
st102:
	if ( ++p == pe )
		goto _test_eof102;
case 102:
	if ( (*p) == 32 )
		goto tr111;
	goto st0;
st103:
	if ( ++p == pe )
		goto _test_eof103;
case 103:
	if ( (*p) == 111 )
		goto st104;
	goto st0;
st104:
	if ( ++p == pe )
		goto _test_eof104;
case 104:
	if ( (*p) == 118 )
		goto st105;
	goto st0;
st105:
	if ( ++p == pe )
		goto _test_eof105;
case 105:
	if ( (*p) == 105 )
		goto st106;
	goto st0;
st106:
	if ( ++p == pe )
		goto _test_eof106;
case 106:
	if ( (*p) == 100 )
		goto st107;
	goto st0;
st107:
	if ( ++p == pe )
		goto _test_eof107;
case 107:
	if ( (*p) == 101 )
		goto st108;
	goto st0;
st108:
	if ( ++p == pe )
		goto _test_eof108;
case 108:
	if ( (*p) == 115 )
		goto st109;
	goto st0;
st109:
	if ( ++p == pe )
		goto _test_eof109;
case 109:
	if ( (*p) == 32 )
		goto tr118;
	goto st0;
st110:
	if ( ++p == pe )
		goto _test_eof110;
case 110:
	if ( (*p) == 101 )
		goto st111;
	goto st0;
st111:
	if ( ++p == pe )
		goto _test_eof111;
case 111:
	if ( (*p) == 112 )
		goto st112;
	goto st0;
st112:
	if ( ++p == pe )
		goto _test_eof112;
case 112:
	if ( (*p) == 108 )
		goto st113;
	goto st0;
st113:
	if ( ++p == pe )
		goto _test_eof113;
case 113:
	if ( (*p) == 97 )
		goto st114;
	goto st0;
st114:
	if ( ++p == pe )
		goto _test_eof114;
case 114:
	if ( (*p) == 99 )
		goto st115;
	goto st0;
st115:
	if ( ++p == pe )
		goto _test_eof115;
case 115:
	if ( (*p) == 101 )
		goto st116;
	goto st0;
st116:
	if ( ++p == pe )
		goto _test_eof116;
case 116:
	if ( (*p) == 115 )
		goto st117;
	goto st0;
st117:
	if ( ++p == pe )
		goto _test_eof117;
case 117:
	if ( (*p) == 32 )
		goto tr126;
	goto st0;
st118:
	if ( ++p == pe )
		goto _test_eof118;
case 118:
	if ( (*p) == 105 )
		goto st119;
	goto st0;
st119:
	if ( ++p == pe )
		goto _test_eof119;
case 119:
	if ( (*p) == 122 )
		goto st120;
	goto st0;
st120:
	if ( ++p == pe )
		goto _test_eof120;
case 120:
	if ( (*p) == 101 )
		goto st121;
	goto st0;
st121:
	if ( ++p == pe )
		goto _test_eof121;
case 121:
	if ( (*p) == 32 )
		goto tr130;
	goto st0;
st122:
	if ( ++p == pe )
		goto _test_eof122;
case 122:
	if ( (*p) == 114 )
		goto st123;
	goto st0;
st123:
	if ( ++p == pe )
		goto _test_eof123;
case 123:
	if ( (*p) == 108 )
		goto st124;
	goto st0;
st124:
	if ( ++p == pe )
		goto _test_eof124;
case 124:
	if ( (*p) == 32 )
		goto tr133;
	goto st0;
	}
	_test_eof125:  parser->cs = 125; goto _test_eof; 
	_test_eof1:  parser->cs = 1; goto _test_eof; 
	_test_eof2:  parser->cs = 2; goto _test_eof; 
	_test_eof3:  parser->cs = 3; goto _test_eof; 
	_test_eof4:  parser->cs = 4; goto _test_eof; 
	_test_eof5:  parser->cs = 5; goto _test_eof; 
	_test_eof6:  parser->cs = 6; goto _test_eof; 
	_test_eof7:  parser->cs = 7; goto _test_eof; 
	_test_eof8:  parser->cs = 8; goto _test_eof; 
	_test_eof9:  parser->cs = 9; goto _test_eof; 
	_test_eof10:  parser->cs = 10; goto _test_eof; 
	_test_eof11:  parser->cs = 11; goto _test_eof; 
	_test_eof12:  parser->cs = 12; goto _test_eof; 
	_test_eof13:  parser->cs = 13; goto _test_eof; 
	_test_eof14:  parser->cs = 14; goto _test_eof; 
	_test_eof15:  parser->cs = 15; goto _test_eof; 
	_test_eof16:  parser->cs = 16; goto _test_eof; 
	_test_eof17:  parser->cs = 17; goto _test_eof; 
	_test_eof18:  parser->cs = 18; goto _test_eof; 
	_test_eof19:  parser->cs = 19; goto _test_eof; 
	_test_eof20:  parser->cs = 20; goto _test_eof; 
	_test_eof21:  parser->cs = 21; goto _test_eof; 
	_test_eof22:  parser->cs = 22; goto _test_eof; 
	_test_eof23:  parser->cs = 23; goto _test_eof; 
	_test_eof24:  parser->cs = 24; goto _test_eof; 
	_test_eof25:  parser->cs = 25; goto _test_eof; 
	_test_eof26:  parser->cs = 26; goto _test_eof; 
	_test_eof27:  parser->cs = 27; goto _test_eof; 
	_test_eof28:  parser->cs = 28; goto _test_eof; 
	_test_eof29:  parser->cs = 29; goto _test_eof; 
	_test_eof30:  parser->cs = 30; goto _test_eof; 
	_test_eof31:  parser->cs = 31; goto _test_eof; 
	_test_eof32:  parser->cs = 32; goto _test_eof; 
	_test_eof33:  parser->cs = 33; goto _test_eof; 
	_test_eof34:  parser->cs = 34; goto _test_eof; 
	_test_eof35:  parser->cs = 35; goto _test_eof; 
	_test_eof36:  parser->cs = 36; goto _test_eof; 
	_test_eof37:  parser->cs = 37; goto _test_eof; 
	_test_eof38:  parser->cs = 38; goto _test_eof; 
	_test_eof39:  parser->cs = 39; goto _test_eof; 
	_test_eof40:  parser->cs = 40; goto _test_eof; 
	_test_eof41:  parser->cs = 41; goto _test_eof; 
	_test_eof42:  parser->cs = 42; goto _test_eof; 
	_test_eof43:  parser->cs = 43; goto _test_eof; 
	_test_eof44:  parser->cs = 44; goto _test_eof; 
	_test_eof45:  parser->cs = 45; goto _test_eof; 
	_test_eof46:  parser->cs = 46; goto _test_eof; 
	_test_eof47:  parser->cs = 47; goto _test_eof; 
	_test_eof48:  parser->cs = 48; goto _test_eof; 
	_test_eof49:  parser->cs = 49; goto _test_eof; 
	_test_eof50:  parser->cs = 50; goto _test_eof; 
	_test_eof51:  parser->cs = 51; goto _test_eof; 
	_test_eof52:  parser->cs = 52; goto _test_eof; 
	_test_eof53:  parser->cs = 53; goto _test_eof; 
	_test_eof54:  parser->cs = 54; goto _test_eof; 
	_test_eof55:  parser->cs = 55; goto _test_eof; 
	_test_eof56:  parser->cs = 56; goto _test_eof; 
	_test_eof57:  parser->cs = 57; goto _test_eof; 
	_test_eof58:  parser->cs = 58; goto _test_eof; 
	_test_eof59:  parser->cs = 59; goto _test_eof; 
	_test_eof60:  parser->cs = 60; goto _test_eof; 
	_test_eof61:  parser->cs = 61; goto _test_eof; 
	_test_eof62:  parser->cs = 62; goto _test_eof; 
	_test_eof63:  parser->cs = 63; goto _test_eof; 
	_test_eof64:  parser->cs = 64; goto _test_eof; 
	_test_eof65:  parser->cs = 65; goto _test_eof; 
	_test_eof66:  parser->cs = 66; goto _test_eof; 
	_test_eof67:  parser->cs = 67; goto _test_eof; 
	_test_eof68:  parser->cs = 68; goto _test_eof; 
	_test_eof69:  parser->cs = 69; goto _test_eof; 
	_test_eof70:  parser->cs = 70; goto _test_eof; 
	_test_eof71:  parser->cs = 71; goto _test_eof; 
	_test_eof72:  parser->cs = 72; goto _test_eof; 
	_test_eof73:  parser->cs = 73; goto _test_eof; 
	_test_eof74:  parser->cs = 74; goto _test_eof; 
	_test_eof75:  parser->cs = 75; goto _test_eof; 
	_test_eof76:  parser->cs = 76; goto _test_eof; 
	_test_eof77:  parser->cs = 77; goto _test_eof; 
	_test_eof78:  parser->cs = 78; goto _test_eof; 
	_test_eof79:  parser->cs = 79; goto _test_eof; 
	_test_eof80:  parser->cs = 80; goto _test_eof; 
	_test_eof81:  parser->cs = 81; goto _test_eof; 
	_test_eof82:  parser->cs = 82; goto _test_eof; 
	_test_eof83:  parser->cs = 83; goto _test_eof; 
	_test_eof84:  parser->cs = 84; goto _test_eof; 
	_test_eof85:  parser->cs = 85; goto _test_eof; 
	_test_eof86:  parser->cs = 86; goto _test_eof; 
	_test_eof87:  parser->cs = 87; goto _test_eof; 
	_test_eof88:  parser->cs = 88; goto _test_eof; 
	_test_eof89:  parser->cs = 89; goto _test_eof; 
	_test_eof90:  parser->cs = 90; goto _test_eof; 
	_test_eof91:  parser->cs = 91; goto _test_eof; 
	_test_eof92:  parser->cs = 92; goto _test_eof; 
	_test_eof93:  parser->cs = 93; goto _test_eof; 
	_test_eof94:  parser->cs = 94; goto _test_eof; 
	_test_eof95:  parser->cs = 95; goto _test_eof; 
	_test_eof96:  parser->cs = 96; goto _test_eof; 
	_test_eof97:  parser->cs = 97; goto _test_eof; 
	_test_eof98:  parser->cs = 98; goto _test_eof; 
	_test_eof99:  parser->cs = 99; goto _test_eof; 
	_test_eof100:  parser->cs = 100; goto _test_eof; 
	_test_eof101:  parser->cs = 101; goto _test_eof; 
	_test_eof102:  parser->cs = 102; goto _test_eof; 
	_test_eof103:  parser->cs = 103; goto _test_eof; 
	_test_eof104:  parser->cs = 104; goto _test_eof; 
	_test_eof105:  parser->cs = 105; goto _test_eof; 
	_test_eof106:  parser->cs = 106; goto _test_eof; 
	_test_eof107:  parser->cs = 107; goto _test_eof; 
	_test_eof108:  parser->cs = 108; goto _test_eof; 
	_test_eof109:  parser->cs = 109; goto _test_eof; 
	_test_eof110:  parser->cs = 110; goto _test_eof; 
	_test_eof111:  parser->cs = 111; goto _test_eof; 
	_test_eof112:  parser->cs = 112; goto _test_eof; 
	_test_eof113:  parser->cs = 113; goto _test_eof; 
	_test_eof114:  parser->cs = 114; goto _test_eof; 
	_test_eof115:  parser->cs = 115; goto _test_eof; 
	_test_eof116:  parser->cs = 116; goto _test_eof; 
	_test_eof117:  parser->cs = 117; goto _test_eof; 
	_test_eof118:  parser->cs = 118; goto _test_eof; 
	_test_eof119:  parser->cs = 119; goto _test_eof; 
	_test_eof120:  parser->cs = 120; goto _test_eof; 
	_test_eof121:  parser->cs = 121; goto _test_eof; 
	_test_eof122:  parser->cs = 122; goto _test_eof; 
	_test_eof123:  parser->cs = 123; goto _test_eof; 
	_test_eof124:  parser->cs = 124; goto _test_eof; 

	_test_eof: {}
	_out: {}
	}

#line 71 "src/pkginfo.rl"

    (void)pkginfo_en_main;
    if (parser->cs == pkginfo_error)
        return -1;

    return buf_len;
}

ssize_t read_pkginfo(struct archive *archive, struct pkg *pkg)
{
    char *buf;
    ssize_t nbytes_r = 0;
    struct pkginfo_parser parser;
    pkginfo_parser_init(&parser);

    for (;;) {
        size_t bufsize;
        archive_read(archive, &buf, &bufsize);

        ssize_t result = pkginfo_parser_feed(&parser, pkg, buf, bufsize);
        if (result < 0) {
            return result;
        } else {
            nbytes_r += result;
        }

        break;
    }

    return nbytes_r;
}
